name: Test

on: [push, pull_request]

jobs:
  test:

    runs-on: ${{ matrix.os }}
    strategy:
      matrix:
        os: [macos-latest, ubuntu-latest, windows-latest]
        python-version: [3.7, 3.8, 3.9]

    steps:
    - uses: actions/checkout@v1

    - name: Set up Python ${{ matrix.python-version }}
      uses: actions/setup-python@v1
      with:
        python-version: ${{ matrix.python-version }}

    - name: setup apt dependencies for Linux
      if: ${{ matrix.os == 'ubuntu-latest' }}
      run: |
        sudo apt-get update
        sudo apt-get install opencl-headers ocl-icd-opencl-dev libpocl2

    - name: Install Python dependencies
      run: |
        python -m pip install --upgrade pip
        python -m pip install wheel setuptools
        python -m pip install mako
        python -m pip install numpy scipy matplotlib docutils pytest sphinx bumps unittest-xml-reporting tinycc

    - name: setup pyopencl on Linux + macOS
      if: ${{ matrix.os != 'windows-latest' }}
      run: |
        python -m pip install pyopencl

    - name: setup pyopencl on Windows
      if: ${{ matrix.os == 'windows-latest' }}
      run: |
        python -m pip install pytools mako cffi

        choco install opencl-intel-cpu-runtime
        python -m pip install --only-binary=pyopencl --find-links http://www.silx.org/pub/wheelhouse/ --trusted-host www.silx.org pyopencl

    - name: Test with pytest
      env:
        PYOPENCL_COMPILER_OUTPUT: 1
      run: |
        # other CI uses the following, but `setup.py test` is a deprecated way
        # of running tests
        # python setup.py test --pytest-args -v

        pytest -v

    - name: check that the docs build (linux only)
      if: ${{ matrix.os == 'ubuntu-latest' }}
      run: |
        make -j 4 -C doc SPHINXOPTS="-W --keep-going -n" html
